import{s as kt,n as jt,o as It}from"../chunks/scheduler.b108d059.js";import{S as Wt,i as Vt,g as a,s as o,r as p,A as Bt,h as s,f as l,c as i,j as Ht,u as m,x as f,k as Rt,y as Qt,a as n,v as u,d as r,t as d,w as c}from"../chunks/index.008de539.js";import{C as L}from"../chunks/CodeBlock.3968c746.js";import{H as $}from"../chunks/Heading.88bfeb84.js";function Lt(yt){let g,A,X,F,h,N,w,Y,U,Tt=`We assume the reader has already created a Google Cloud Platform (GCP) user or organisation account and an
associated project.`,D,v,Ct=`We also assume the reader to have the Google Cloud CLI installed. If not please follow the links right after to
<a href="https://cloud.google.com/sdk/docs/install" rel="nofollow">install</a> and <a href="https://cloud.google.com/sdk/docs/initializing" rel="nofollow">setup</a>.`,q,y,O,T,Mt="In order to create your initial TPU instance, you will need to provide some information:",K,C,xt='<li>The <a href="https://cloud.google.com/tpu/docs/regions-zones" rel="nofollow">GCP zone</a> you would like to see the instance being deployed (close to the reader for development purpose, close to the end user for production for instance)</li> <li>Which kind of <a href="https://cloud.google.com/tpu/docs/system-architecture-tpu-vm#versions" rel="nofollow">TPU</a> you would like to target</li> <li>Which version of the <a href="https://cloud.google.com/tpu/docs/runtimes" rel="nofollow">TPU runtime</a> you want to leverage on the instance</li> <li>Custom instance name to quickly skim and refer back to the instance</li>',tt,M,bt="Overall the end command looks like this:",et,x,lt,b,nt,P,Pt=`In our case we will be deploying a <code>v5litepod-8</code> instance name <code>optimum-tpu-get-started</code>
in the GCP region <code>us-west4-a</code> using the latest <code>v2-alpha-tpuv5-lite</code> runtime version.`,ot,Z,Zt="Of course, feel free to adjust all these parameters to the one that match with your usage and quotas.",it,z,zt=`Before creating the instance, please make sure to install <code>gcloud alpha component</code> as it is required to be able to
target TPUv5 VMs: <code>gcloud components install alpha</code>`,at,_,st,J,pt,S,mt,G,_t="In the example above deploying v5litepod-8 it would be something like:",ut,H,rt,R,dt,k,ct,j,Jt="If you want to leverage PyTorch/XLA through Optimum-TPU, it should be as simple as",ft,I,gt,W,St=`Now you can validate the installation with the following command which should print <code>xla:0</code> as we do have a single
TPU device bound to this instance.`,$t,V,ht,B,wt,Q,Gt="JAX is coming soon - stay tuned!",Ut,E,vt;return h=new $({props:{title:"Deploying a Google TPU instance on Google Cloud Platform (GCP)",local:"deploying-a-google-tpu-instance-on-google-cloud-platform-gcp",headingTag:"h1"}}),w=new $({props:{title:"Context",local:"context",headingTag:"h2"}}),y=new $({props:{title:"Creating the initial TPU VM on GCP",local:"creating-the-initial-tpu-vm-on-gcp",headingTag:"h2"}}),x=new L({props:{code:"Z2Nsb3VkJTIwY29tcHV0ZSUyMHRwdXMlMjB0cHUtdm0lMjBjcmVhdGUlMjAlM0NyZWZfaW5zdGFuY2VfbmFtZSUzRSUyMCU1QyUwQS0tem9uZSUzRCUzQ2RlcGxvaW1lbnRfem9uZSUzRSUyMCU1QyUwQS0tYWNjZWxlcmF0b3ItdHlwZSUzRCUzQ3RhcmdldF90cHVfZ2VuZXJhdGlvbiUzRSUyMCU1QyUwQS0tdmVyc2lvbiUzRCUzQ3J1bnRpbWVfdmVyc2lvbiUzRQ==",highlighted:`gcloud compute tpus tpu-vm create &lt;ref_instance_name&gt; \\
--zone=&lt;deploiment_zone&gt; \\
--accelerator-type=&lt;target_tpu_generation&gt; \\
--version=&lt;runtime_version&gt;`,wrap:!1}}),b=new $({props:{title:"Deploying a TPU v5litepod-8 instance",local:"deploying-a-tpu-v5litepod-8-instance",headingTag:"h3"}}),_=new L({props:{code:"Z2Nsb3VkJTIwYWxwaGElMjBjb21wdXRlJTIwdHB1cyUyMHRwdS12bSUyMGNyZWF0ZSUyMG9wdGltdW0tdHB1LWdldC1zdGFydGVkJTIwJTVDJTBBLS16b25lJTNEdXMtd2VzdDQtYSUyMCU1QyUwQS0tYWNjZWxlcmF0b3ItdHlwZSUzRHY1bGl0ZXBvZC04JTIwJTVDJTBBLS12ZXJzaW9uJTNEdjItYWxwaGEtdHB1djUtbGl0ZQ==",highlighted:`gcloud alpha compute tpus tpu-vm create optimum-tpu-get-started \\
--zone=us-west4-a \\
--accelerator-type=v5litepod-8 \\
--version=v2-alpha-tpuv5-lite`,wrap:!1}}),J=new $({props:{title:"Connecting to the instance",local:"connecting-to-the-instance",headingTag:"h2"}}),S=new L({props:{code:"Z2Nsb3VkJTIwY29tcHV0ZSUyMHRwdXMlMjB0cHUtdm0lMjBzc2glMjAlM0NyZWZfaW5zdGFuY2VfbmFtZSUzRSUyMC0tem9uZSUzRCUzQ2RlcGxveW1lbnRfem9uZSUzRSUwQSUyNCUyMCUzRQ==",highlighted:`gcloud compute tpus tpu-vm ssh &lt;ref_instance_name&gt; --zone=&lt;deployment_zone&gt;
$ &gt;`,wrap:!1}}),H=new L({props:{code:"Z2Nsb3VkJTIwY29tcHV0ZSUyMHRwdXMlMjB0cHUtdm0lMjBzc2glMjBvcHRpbXVtLXRwdS1nZXQtc3RhcnRlZCUyMC0tem9uZSUzRHVzLXdlc3Q0LWElMEElMjQlMjAlM0U=",highlighted:`gcloud compute tpus tpu-vm ssh optimum-tpu-get-started --zone=us-west4-a
$ &gt;`,wrap:!1}}),R=new $({props:{title:"Setting up the instance to run AI workloads on TPUs",local:"setting-up-the-instance-to-run-ai-workloads-on-tpus",headingTag:"h2"}}),k=new $({props:{title:"Optimum-TPU with PyTorch/XLA",local:"optimum-tpu-with-pytorchxla",headingTag:"h3"}}),I=new L({props:{code:"JTI0JTIwcHl0aG9uMyUyMC1tJTIwcGlwJTIwaW5zdGFsbCUyMG9wdGltdW0tdHB1JTIwLWYlMjBodHRwcyUzQSUyRiUyRnN0b3JhZ2UuZ29vZ2xlYXBpcy5jb20lMkZsaWJ0cHUtcmVsZWFzZXMlMkZpbmRleC5odG1sJTBBJTI0JTIwZXhwb3J0JTIwUEpSVF9ERVZJQ0UlM0RUUFU=",highlighted:`$ python3 -m pip install optimum-tpu -f https://storage.googleapis.com/libtpu-releases/index.html
$ <span class="hljs-built_in">export</span> PJRT_DEVICE=TPU`,wrap:!1}}),V=new L({props:{code:"JTI0JTIwcHl0aG9uJTIwLWMlMjAlMjJpbXBvcnQlMjB0b3JjaF94bGEuY29yZS54bGFfbW9kZWwlMjBhcyUyMHhtJTNCJTIwcHJpbnQoeG0ueGxhX2RldmljZSgpKSUyMiUwQXhsYSUzQTA=",highlighted:`$ python -c <span class="hljs-string">&quot;import torch_xla.core.xla_model as xm; print(xm.xla_device())&quot;</span>
xla:0`,wrap:!1}}),B=new $({props:{title:"Optimum-TPU with JAX",local:"optimum-tpu-with-jax",headingTag:"h3"}}),{c(){g=a("meta"),A=o(),X=a("p"),F=o(),p(h.$$.fragment),N=o(),p(w.$$.fragment),Y=o(),U=a("p"),U.textContent=Tt,D=o(),v=a("p"),v.innerHTML=Ct,q=o(),p(y.$$.fragment),O=o(),T=a("p"),T.textContent=Mt,K=o(),C=a("ul"),C.innerHTML=xt,tt=o(),M=a("p"),M.textContent=bt,et=o(),p(x.$$.fragment),lt=o(),p(b.$$.fragment),nt=o(),P=a("p"),P.innerHTML=Pt,ot=o(),Z=a("p"),Z.textContent=Zt,it=o(),z=a("p"),z.innerHTML=zt,at=o(),p(_.$$.fragment),st=o(),p(J.$$.fragment),pt=o(),p(S.$$.fragment),mt=o(),G=a("p"),G.textContent=_t,ut=o(),p(H.$$.fragment),rt=o(),p(R.$$.fragment),dt=o(),p(k.$$.fragment),ct=o(),j=a("p"),j.textContent=Jt,ft=o(),p(I.$$.fragment),gt=o(),W=a("p"),W.innerHTML=St,$t=o(),p(V.$$.fragment),ht=o(),p(B.$$.fragment),wt=o(),Q=a("p"),Q.textContent=Gt,Ut=o(),E=a("p"),this.h()},l(t){const e=Bt("svelte-u9bgzb",document.head);g=s(e,"META",{name:!0,content:!0}),e.forEach(l),A=i(t),X=s(t,"P",{}),Ht(X).forEach(l),F=i(t),m(h.$$.fragment,t),N=i(t),m(w.$$.fragment,t),Y=i(t),U=s(t,"P",{"data-svelte-h":!0}),f(U)!=="svelte-erf97f"&&(U.textContent=Tt),D=i(t),v=s(t,"P",{"data-svelte-h":!0}),f(v)!=="svelte-264pl4"&&(v.innerHTML=Ct),q=i(t),m(y.$$.fragment,t),O=i(t),T=s(t,"P",{"data-svelte-h":!0}),f(T)!=="svelte-n1fuae"&&(T.textContent=Mt),K=i(t),C=s(t,"UL",{"data-svelte-h":!0}),f(C)!=="svelte-n5qio1"&&(C.innerHTML=xt),tt=i(t),M=s(t,"P",{"data-svelte-h":!0}),f(M)!=="svelte-1mb5j9l"&&(M.textContent=bt),et=i(t),m(x.$$.fragment,t),lt=i(t),m(b.$$.fragment,t),nt=i(t),P=s(t,"P",{"data-svelte-h":!0}),f(P)!=="svelte-m223dm"&&(P.innerHTML=Pt),ot=i(t),Z=s(t,"P",{"data-svelte-h":!0}),f(Z)!=="svelte-ipoz1i"&&(Z.textContent=Zt),it=i(t),z=s(t,"P",{"data-svelte-h":!0}),f(z)!=="svelte-1un03r3"&&(z.innerHTML=zt),at=i(t),m(_.$$.fragment,t),st=i(t),m(J.$$.fragment,t),pt=i(t),m(S.$$.fragment,t),mt=i(t),G=s(t,"P",{"data-svelte-h":!0}),f(G)!=="svelte-nx4k2f"&&(G.textContent=_t),ut=i(t),m(H.$$.fragment,t),rt=i(t),m(R.$$.fragment,t),dt=i(t),m(k.$$.fragment,t),ct=i(t),j=s(t,"P",{"data-svelte-h":!0}),f(j)!=="svelte-1knmexs"&&(j.textContent=Jt),ft=i(t),m(I.$$.fragment,t),gt=i(t),W=s(t,"P",{"data-svelte-h":!0}),f(W)!=="svelte-5yzmiv"&&(W.innerHTML=St),$t=i(t),m(V.$$.fragment,t),ht=i(t),m(B.$$.fragment,t),wt=i(t),Q=s(t,"P",{"data-svelte-h":!0}),f(Q)!=="svelte-c57izm"&&(Q.textContent=Gt),Ut=i(t),E=s(t,"P",{}),Ht(E).forEach(l),this.h()},h(){Rt(g,"name","hf:doc:metadata"),Rt(g,"content",Xt)},m(t,e){Qt(document.head,g),n(t,A,e),n(t,X,e),n(t,F,e),u(h,t,e),n(t,N,e),u(w,t,e),n(t,Y,e),n(t,U,e),n(t,D,e),n(t,v,e),n(t,q,e),u(y,t,e),n(t,O,e),n(t,T,e),n(t,K,e),n(t,C,e),n(t,tt,e),n(t,M,e),n(t,et,e),u(x,t,e),n(t,lt,e),u(b,t,e),n(t,nt,e),n(t,P,e),n(t,ot,e),n(t,Z,e),n(t,it,e),n(t,z,e),n(t,at,e),u(_,t,e),n(t,st,e),u(J,t,e),n(t,pt,e),u(S,t,e),n(t,mt,e),n(t,G,e),n(t,ut,e),u(H,t,e),n(t,rt,e),u(R,t,e),n(t,dt,e),u(k,t,e),n(t,ct,e),n(t,j,e),n(t,ft,e),u(I,t,e),n(t,gt,e),n(t,W,e),n(t,$t,e),u(V,t,e),n(t,ht,e),u(B,t,e),n(t,wt,e),n(t,Q,e),n(t,Ut,e),n(t,E,e),vt=!0},p:jt,i(t){vt||(r(h.$$.fragment,t),r(w.$$.fragment,t),r(y.$$.fragment,t),r(x.$$.fragment,t),r(b.$$.fragment,t),r(_.$$.fragment,t),r(J.$$.fragment,t),r(S.$$.fragment,t),r(H.$$.fragment,t),r(R.$$.fragment,t),r(k.$$.fragment,t),r(I.$$.fragment,t),r(V.$$.fragment,t),r(B.$$.fragment,t),vt=!0)},o(t){d(h.$$.fragment,t),d(w.$$.fragment,t),d(y.$$.fragment,t),d(x.$$.fragment,t),d(b.$$.fragment,t),d(_.$$.fragment,t),d(J.$$.fragment,t),d(S.$$.fragment,t),d(H.$$.fragment,t),d(R.$$.fragment,t),d(k.$$.fragment,t),d(I.$$.fragment,t),d(V.$$.fragment,t),d(B.$$.fragment,t),vt=!1},d(t){t&&(l(A),l(X),l(F),l(N),l(Y),l(U),l(D),l(v),l(q),l(O),l(T),l(K),l(C),l(tt),l(M),l(et),l(lt),l(nt),l(P),l(ot),l(Z),l(it),l(z),l(at),l(st),l(pt),l(mt),l(G),l(ut),l(rt),l(dt),l(ct),l(j),l(ft),l(gt),l(W),l($t),l(ht),l(wt),l(Q),l(Ut),l(E)),l(g),c(h,t),c(w,t),c(y,t),c(x,t),c(b,t),c(_,t),c(J,t),c(S,t),c(H,t),c(R,t),c(k,t),c(I,t),c(V,t),c(B,t)}}}const Xt='{"title":"Deploying a Google TPU instance on Google Cloud Platform (GCP)","local":"deploying-a-google-tpu-instance-on-google-cloud-platform-gcp","sections":[{"title":"Context","local":"context","sections":[],"depth":2},{"title":"Creating the initial TPU VM on GCP","local":"creating-the-initial-tpu-vm-on-gcp","sections":[{"title":"Deploying a TPU v5litepod-8 instance","local":"deploying-a-tpu-v5litepod-8-instance","sections":[],"depth":3}],"depth":2},{"title":"Connecting to the instance","local":"connecting-to-the-instance","sections":[],"depth":2},{"title":"Setting up the instance to run AI workloads on TPUs","local":"setting-up-the-instance-to-run-ai-workloads-on-tpus","sections":[{"title":"Optimum-TPU with PyTorch/XLA","local":"optimum-tpu-with-pytorchxla","sections":[],"depth":3},{"title":"Optimum-TPU with JAX","local":"optimum-tpu-with-jax","sections":[],"depth":3}],"depth":2}],"depth":1}';function Et(yt){return It(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Dt extends Wt{constructor(g){super(),Vt(this,g,Et,Lt,kt,{})}}export{Dt as component};
